VERSION 5.00
Begin VB.Form frm_Suchen 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "IP-Suche"
   ClientHeight    =   2040
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   4680
   Icon            =   "frm_Suchen.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2040
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmd_Quit 
      Caption         =   "eXiT"
      Height          =   315
      Left            =   1770
      TabIndex        =   4
      Top             =   1650
      Width           =   1185
   End
   Begin VB.TextBox txt_IP 
      Alignment       =   2  'Center
      Height          =   345
      Left            =   960
      Locked          =   -1  'True
      TabIndex        =   3
      Top             =   1170
      Width           =   2865
   End
   Begin VB.TextBox txt_Hostname 
      Alignment       =   2  'Center
      Height          =   345
      Left            =   960
      TabIndex        =   1
      Top             =   480
      Width           =   2865
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Zum Hostname verbundene IP-Adresse:"
      Height          =   225
      Left            =   960
      TabIndex        =   2
      Top             =   900
      Width           =   2835
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Gebe den Hostname ein:"
      Height          =   225
      Left            =   960
      TabIndex        =   0
      Top             =   150
      Width           =   2805
   End
End
Attribute VB_Name = "frm_Suchen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Const WS_VERSION_REQD = &H101
Private Const WS_VERSION_MAJOR = WS_VERSION_REQD \ &H100 And &HFF&
Private Const WS_VERSION_MINOR = WS_VERSION_REQD And &HFF&
Private Const MIN_SOCKETS_REQD = 1
Private Const SOCKET_ERROR = -1
Private Const WSADescription_Len = 256
Private Const WSASYS_Status_Len = 128

Private Type HOSTENT
   hName As Long
   hAliases As Long
   hAddrType As Integer
   hLength As Integer
   hAddrList As Long
End Type

Private Type WSADATA
   wversion As Integer
   wHighVersion As Integer
   szDescription(0 To WSADescription_Len) As Byte
   szSystemStatus(0 To WSASYS_Status_Len) As Byte
   iMaxSockets As Integer
   iMaxUdpDg As Integer
   lpszVendorInfo As Long
End Type

Private Declare Function WSAGetLastError Lib "WSOCK32.DLL" () As Long
Private Declare Function WSAStartup Lib "WSOCK32.DLL" (ByVal wVersionRequired&, lpWSAData As WSADATA) As Long
Private Declare Function WSACleanup Lib "WSOCK32.DLL" () As Long
Private Declare Function gethostbyname Lib "WSOCK32.DLL" (ByVal Hostname$) As Long
Private Declare Sub RtlMoveMemory Lib "KERNEL32" (hpvDest As Any, ByVal hpvSource&, ByVal cbCopy&)

Function hibyte(ByVal wParam As Integer)
   
   hibyte = wParam \ &H100 And &HFF&
   
End Function

Function lobyte(ByVal wParam As Integer)
   
   lobyte = wParam And &HFF&
   
End Function

Sub SocketsInitialize()
   On Error GoTo Fehler
   Dim WSAD As WSADATA
   Dim iReturn As Integer
   Dim sLowByte As String, sHighByte As String, sMsg As String
   
   iReturn = WSAStartup(WS_VERSION_REQD, WSAD)
   
   If iReturn <> 0 Then
      MsgBox "Winsock.dll kann nicht gefunden werden.", vbCritical, "Error"
      Unload Me
   End If
   
   If lobyte(WSAD.wversion) < WS_VERSION_MAJOR Or (lobyte(WSAD.wversion) = WS_VERSION_MAJOR And hibyte(WSAD.wversion) < WS_VERSION_MINOR) Then
      sHighByte = Trim$(Str$(hibyte(WSAD.wversion)))
      sLowByte = Trim$(Str$(lobyte(WSAD.wversion)))
      sMsg = "Windows Sockets Version " & sLowByte & "." & sHighByte
      sMsg = sMsg & " wird nicht untersttzt von winsock.dll "
      MsgBox sMsg, vbCritical, "winsock.dll Error"
      End
   End If
   
   If WSAD.iMaxSockets < MIN_SOCKETS_REQD Then
      sMsg = "Diese Anwendung bentigt ein Minimum von "
      sMsg = sMsg & Trim$(Str$(MIN_SOCKETS_REQD)) & " untersttzten Sockets."
      MsgBox sMsg, vbCritical, "Resourcenkonflikt"
      End
   End If
Fehler:
Select Case Err
    Case 11
        Exit Sub
End Select
End Sub

Sub SocketsCleanup()
   Dim lReturn As Long
   
   lReturn = WSACleanup()
   
   If lReturn <> 0 Then
      MsgBox "Socket Fehler " & Trim$(Str$(lReturn)) & " in Cleanup ", vbCritical, "Error"
      End
   End If
   
End Sub


Private Sub cmd_Quit_Click()
Grundform.Show
Unload Me
End Sub

Private Sub Form_Load()
   SocketsInitialize
   txt_Hostname.Text = Grundform.Winsock1.LocalHostName
   txt_Hostname.SelStart = 0
   txt_Hostname.SelLength = Len(txt_Hostname.Text)
End Sub

Private Sub Form_Unload(Cancel As Integer)
   SocketsCleanup
   Grundform.Show
End Sub

Private Sub txt_Hostname_KeyUp(KeyCode As Integer, Shift As Integer)
 If KeyCode = 13 And txt_Hostname <> "" Then
   Dim hostent_addr As Long
   Dim Host As HOSTENT
   Dim hostip_addr As Long
   Dim temp_ip_address() As Byte
   Dim i As Integer
   Dim ip_address As String
   
   hostent_addr = gethostbyname(txt_Hostname)
   
   If hostent_addr = 0 Then
      MsgBox "Die IP konnte nicht identifiziert werden", vbCritical, "Host nicht gefunden"
      Exit Sub
   End If
   
   RtlMoveMemory Host, hostent_addr, LenB(Host)
   RtlMoveMemory hostip_addr, Host.hAddrList, 4
   
   ReDim temp_ip_address(1 To Host.hLength)
   RtlMoveMemory temp_ip_address(1), hostip_addr, Host.hLength
   
   For i = 1 To Host.hLength
      ip_address = ip_address & temp_ip_address(i) & "."
   Next
   ip_address = Mid$(ip_address, 1, Len(ip_address) - 1)
   
   txt_IP.Text = ip_address
   
   txt_IP.SetFocus
   txt_IP.SelStart = 0
   txt_IP.SelLength = Len(txt_IP.Text)
End If
End Sub

Private Sub txt_IP_KeyUp(KeyCode As Integer, Shift As Integer)
If KeyCode = 13 And txt_IP.Text <> "" Then
    Grundform.Show
    Grundform.txt_IP.Text = txt_IP.Text
    Grundform.cmd_Scan_starten.SetFocus
    Unload Me
End If
End Sub
